diff -c -w files-CVS-2008-02-29.el" "files-patched-2008-02-29.el"
*** files-CVS-2008-02-29.el	Fri Feb 29 14:59:08 2008
--- files-patched-2008-02-29.el	Fri Feb 29 15:17:20 2008
***************
*** 5284,5303 ****
  		      (if val
  			  (put-text-property pos (point)
  					     'dired-filename t)))))))
! 
! 	  (if full-directory-p
! 	      ;; Try to insert the amount of free space.
  	      (save-excursion
  		(goto-char beg)
! 		;; First find the line to put it on.
! 		(when (re-search-forward "^ *\\(total\\)" nil t)
! 		  (let ((available (get-free-disk-space ".")))
  		    (when available
- 		      ;; Replace "total" with "used", to avoid confusion.
- 		      (replace-match "total used in directory" nil nil nil 1)
  		      (end-of-line)
  		      (insert " available " available)))))))))))
  
  (defun insert-directory-adj-pos (pos error-lines)
    "Convert `ls --dired' file name position value POS to a buffer position.
  File name position values returned in ls --dired output
--- 5284,5336 ----
  		      (if val
  			  (put-text-property pos (point)
  					     'dired-filename t)))))))
! 	  (when full-directory-p
              (save-excursion
                (goto-char beg)
!               (while (re-search-forward "^ *\\(total\\)" nil t)
!                 (beginning-of-line)
!                 (insert "files " (number-to-string (save-match-data
!                                                      (count-dired-files)))
!                         " ")
!                 (goto-char beg)
!                 (re-search-forward "^files [0-9]+ \\(total\\)" nil t)
!                 (replace-match "space used" nil nil nil 1)
!                 (let ((available (and (fboundp 'get-free-disk-space)
!                                       (get-free-disk-space "."))))
                    (when available
                      (end-of-line)
                      (insert " available " available)))))))))))
  
+ (defun count-dired-files ()
+   "Returns the number of files in the current Dired directory listing.
+ This includes directory entries, as well as files, but it excludes `.'
+ and `..'."
+   ;; Should we skip `#' files also, as in `dired-trivial-filenames'? Dunno.
+   (save-excursion
+     (re-search-backward "^$" nil 'to-bob)
+     (re-search-forward dired-move-to-filename-regexp nil t)
+     (let* ((beg (line-beginning-position))
+            (end (save-excursion (re-search-forward "^$" nil t)))
+            (dots-p (save-excursion      ; Is `..' present?
+                      (goto-char beg)
+                      (re-search-forward
+                       (concat directory-listing-before-filename-regexp
+                               "\\.\\./?$")
+                       end t))))
+       (if dots-p (- (count-lines beg end) 2) (count-lines beg end)))))
+ 
+ (add-hook 'dired-after-readin-hook 'update-dired-files-count)
+ (defun update-dired-files-count ()
+   "Update file count in Dired header for each directory listed."
+   (let ((num-files (number-to-string (count-dired-files))))
+     (save-excursion
+       (goto-char (point-min))
+       (while (re-search-forward "^  files \\([0-9]+\\)" nil t)
+         (let ((buffer-read-only nil))
+           (replace-match (number-to-string (save-match-data (count-dired-files)))
+                          nil nil nil 1))
+         (set-buffer-modified-p nil)))))
+ 
  (defun insert-directory-adj-pos (pos error-lines)
    "Convert `ls --dired' file name position value POS to a buffer position.
  File name position values returned in ls --dired output

Diff finished at Fri Feb 29 15:17:44
